# TypeDB Client for Julia

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://Humans-of-Julia.github.io/TypeDBClient.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://Humans-of-Julia.github.io/TypeDBClient.jl/dev)
[![Build Status](https://github.com/Humans-of-Julia/TypeDBClient.jl/workflows/CI/badge.svg)](https://github.com/Humans-of-Julia/TypeDBClient.jl/actions)
[![BDD](https://github.com/Humans-of-Julia/TypeDBClient.jl/actions/workflows/BDD-runner.yml/badge.svg?branch=main)](https://github.com/Humans-of-Julia/TypeDBClient.jl/actions/workflows/BDD-runner.yml)
[![codecov](https://codecov.io/gh/Humans-of-Julia/TypeDBClient.jl/branch/main/graph/badge.svg?token=9SQ8WB8KVM)](https://codecov.io/gh/Humans-of-Julia/TypeDBClient.jl)

This is a community approach to translate a given client interface to the knowledge graph database TypeDB, made by [Vaticle](https://vaticle.com/), into Julia Language.

Starting out as an educational project and to benefit the Julia ecosystem.

Please review the user guide or if you'd like to help building this check the contribution guidlines in the docs.

## What is TypeDB about

Read up here: https://vaticle.com/

> TypeDB is the knowledge graph engine to organise complex networks of data and making it queryable, by performing knowledge engineering. Rooted in Knowledge Representation and Automated Reasoning, TypeDB provides the
> knowledge foundation for cognitive and intelligent (e.g. AI) systems, by providing an intelligent language for modelling, transactions and analytics. Being a distributed database, TypeDB is designed to scale over a
> network of computers through partitioning and replication.

## Announcements

TypeDB 2.0 has been released, these are the highlights of the new version:

    Replaced Cassandra with RocksDB
    New Graph Storage Engine: replacing JanusGraph
    New TypeDB Type System: our Knowledge Representation
    New Graql: even simpler and more powerful
    New Traversal Engine: replacing TinkerPop/Gremlin
    New Query Planner: an Integer Linear Program
    New Reasoning Engine: based on Event Loop + Actor Model
    New Query Engine: an Asynchronous Producer-Consumer
    New Client-Server Protocol: a Reactive Stream
    New TypeDB Cluster: a Raft based distributed TypeDB
    New TypeDB Console: powered by PicoCLI + JLine
    New Benchmarking System: an Agent-based Simulation
    New Grabl CI/CD: replacing CircleCI

Read about it here in the [forum](https://forum.vaticle.com/t/introducing-typedb-typeql-and-vaticle/2418).

## How to start

Check the docs for install instructions and examples (WIP)

For further questions about how to start, ideally find us on [Discord](https://discord.gg/C5h9D4j).

The TypeDB community also has a Discord server [here](https://discord.gg/HBJXnzRgmx).

Please find open issues that look for help in order to contribute.

## Project status

The current project status can be seen on the [GitHub Project Kanban](https://github.com/Humans-of-Julia/TypeDBClient.jl/projects/1).

Contributions are welcome!
